library benchmarks.src.di.di_benchmark;

import 'package:angular2/di.dart' show Injector, Key;
import 'package:angular2/src/reflection/reflection.dart' show reflector;
import 'package:angular2/src/test_lib/benchmark_util.dart'
    show getIntParameter, bindAction;
import 'package:angular2/src/dom/browser_adapter.dart' show BrowserDomAdapter;

var count = 0;
setupReflector() {
  reflector.registerType(A, {
    'factory': () {
      return new A();
    },
    'parameters': [],
    'annotations': []
  });
  reflector.registerType(B, {
    'factory': (a) {
      return new B(a);
    },
    'parameters': [[A]],
    'annotations': []
  });
  reflector.registerType(C, {
    'factory': (b) {
      return new C(b);
    },
    'parameters': [[B]],
    'annotations': []
  });
  reflector.registerType(D, {
    'factory': (c, b) {
      return new D(c, b);
    },
    'parameters': [[C], [B]],
    'annotations': []
  });
  reflector.registerType(E, {
    'factory': (d, c) {
      return new E(d, c);
    },
    'parameters': [[D], [C]],
    'annotations': []
  });
}
main() {
  BrowserDomAdapter.makeCurrent();
  var iterations = getIntParameter('iterations');
  setupReflector();
  var bindings = [A, B, C, D, E];
  var injector = new Injector(bindings);
  var D_KEY = Key.get(D);
  var E_KEY = Key.get(E);
  var childInjector = injector
      .createChild([])
      .createChild([])
      .createChild([])
      .createChild([])
      .createChild([]);
  getByToken() {
    for (var i = 0; i < iterations; ++i) {
      injector.get(D);
      injector.get(E);
    }
  }
  getByKey() {
    for (var i = 0; i < iterations; ++i) {
      injector.get(D_KEY);
      injector.get(E_KEY);
    }
  }
  getChild() {
    for (var i = 0; i < iterations; ++i) {
      childInjector.get(D);
      childInjector.get(E);
    }
  }
  instantiate() {
    for (var i = 0; i < iterations; ++i) {
      var child = injector.createChild([E]);
      child.get(E);
    }
  }
  bindAction('#getByToken', getByToken);
  bindAction('#getByKey', getByKey);
  bindAction('#getChild', getChild);
  bindAction('#instantiate', instantiate);
}
class A {
  A() {
    count++;
  }
}
class B {
  B(A a) {
    count++;
  }
}
class C {
  C(B b) {
    count++;
  }
}
class D {
  D(C c, B b) {
    count++;
  }
}
class E {
  E(D d, C c) {
    count++;
  }
}
