library benchmarks.src.element_injector.element_injector_benchmark;

import 'package:angular2/src/reflection/reflection.dart' show reflector;
import 'package:angular2/di.dart' show Injector;
import 'package:angular2/src/core/compiler/element_injector.dart'
    show ProtoElementInjector;
import 'package:angular2/src/test_lib/benchmark_util.dart'
    show getIntParameter, bindAction;
import 'package:angular2/src/dom/browser_adapter.dart' show BrowserDomAdapter;

var count = 0;
setupReflector() {
  reflector.registerType(A, {
    'factory': () {
      return new A();
    },
    'parameters': [],
    'annotations': []
  });
  reflector.registerType(B, {
    'factory': () {
      return new B();
    },
    'parameters': [],
    'annotations': []
  });
  reflector.registerType(C, {
    'factory': (a, b) {
      return new C(a, b);
    },
    'parameters': [[A], [B]],
    'annotations': []
  });
}
main() {
  BrowserDomAdapter.makeCurrent();
  var iterations = getIntParameter('iterations');
  setupReflector();
  var appInjector = new Injector([]);
  var bindings = [A, B, C];
  var proto = new ProtoElementInjector(null, 0, bindings);
  var elementInjector = proto.instantiate(null, null);
  instantiate() {
    for (var i = 0; i < iterations; ++i) {
      var ei = proto.instantiate(null, null);
      ei.instantiateDirectives(appInjector, null, null);
    }
  }
  instantiateDirectives() {
    for (var i = 0; i < iterations; ++i) {
      elementInjector.clearDirectives();
      elementInjector.instantiateDirectives(appInjector, null, null);
    }
  }
  bindAction('#instantiate', instantiate);
  bindAction('#instantiateDirectives', instantiateDirectives);
}
class A {
  A() {
    count++;
  }
}
class B {
  B() {
    count++;
  }
}
class C {
  C(A a, B b) {
    count++;
  }
}
