library benchmarks.src.naive_infinite_scroll.index;

import 'package:angular2/src/facade/lang.dart' show int, isBlank;
import 'package:angular2/src/dom/dom_adapter.dart' show DOM;
import 'package:angular2/src/facade/collection.dart' show MapWrapper;
import 'package:angular2/change_detection.dart'
    show Parser, Lexer, ChangeDetector, ChangeDetection;
import 'package:angular2/src/core/exception_handler.dart' show ExceptionHandler;
import 'package:angular2/angular2.dart'
    show
        bootstrap,
        Component,
        Viewport,
        Template,
        ViewContainer,
        Compiler,
        onChange,
        NgElement,
        Decorator;
import 'package:angular2/src/reflection/reflection.dart' show reflector;
import 'package:angular2/src/core/compiler/compiler.dart' show CompilerCache;
import 'package:angular2/src/core/compiler/directive_metadata_reader.dart'
    show DirectiveMetadataReader;
import 'package:angular2/src/core/compiler/shadow_dom_strategy.dart'
    show
        ShadowDomStrategy,
        NativeShadowDomStrategy,
        EmulatedUnscopedShadowDomStrategy;
import 'package:angular2/src/core/compiler/shadow_dom_emulation/content_tag.dart'
    show Content;
import 'package:angular2/src/core/compiler/shadow_dom_emulation/light_dom.dart'
    show DestinationLightDom;
import 'package:angular2/src/core/compiler/template_loader.dart'
    show TemplateLoader;
import 'package:angular2/src/core/compiler/template_resolver.dart'
    show TemplateResolver;
import 'package:angular2/src/core/life_cycle/life_cycle.dart' show LifeCycle;
import 'package:angular2/src/core/compiler/xhr/xhr.dart' show XHR;
import 'package:angular2/src/core/compiler/xhr/xhr_impl.dart' show XHRImpl;
import 'package:angular2/src/core/compiler/url_resolver.dart' show UrlResolver;
import 'package:angular2/src/core/compiler/style_url_resolver.dart'
    show StyleUrlResolver;
import 'package:angular2/src/core/compiler/component_url_mapper.dart'
    show ComponentUrlMapper;
import 'package:angular2/src/core/compiler/style_inliner.dart'
    show StyleInliner;
import 'package:angular2/src/core/compiler/css_processor.dart'
    show CssProcessor;
import 'package:angular2/src/core/compiler/private_component_loader.dart'
    show PrivateComponentLoader;
import 'package:angular2/directives.dart' show If, For;
import './app.dart' show App, setupReflectorForApp;
import './scroll_area.dart'
    show ScrollAreaComponent, setupReflectorForScrollArea;
import './scroll_item.dart'
    show ScrollItemComponent, setupReflectorForScrollItem;
import './cells.dart'
    show
        CompanyNameComponent,
        OpportunityNameComponent,
        OfferingNameComponent,
        AccountCellComponent,
        StageButtonsComponent,
        FormattedCellComponent,
        setupReflectorForCells;
import 'package:angular2/src/core/events/event_manager.dart' show EventManager;

main() {
  setupReflector();
  bootstrap(App);
}
setupReflector() {
  setupReflectorForAngular();
  setupReflectorForApp();
  setupReflectorForScrollArea();
  setupReflectorForScrollItem();
  setupReflectorForCells();
  var evt = '''\$event''';
  reflector.registerGetters({
    'scrollAreas': (o) {
      return o.scrollAreas;
    },
    'length': (o) {
      return o.length;
    },
    'iterableChanges': (o) {
      return o.iterableChanges;
    },
    'scrollArea': (o) {
      return o.scrollArea;
    },
    'item': (o) {
      return o.item;
    },
    'visibleItems': (o) {
      return o.visibleItems;
    },
    'condition': (o) {
      return o.condition;
    },
    'width': (o) {
      return o.width;
    },
    'value': (o) {
      return o.value;
    },
    'href': (o) {
      return o.href;
    },
    'company': (o) {
      return o.company;
    },
    'formattedValue': (o) {
      return o.formattedValue;
    },
    'name': (o) {
      return o.name;
    },
    'style': (o) {
      return o.style;
    },
    'offering': (o) {
      return o.offering;
    },
    'account': (o) {
      return o.account;
    },
    'accountId': (o) {
      return o.accountId;
    },
    'companyNameWidth': (o) {
      return o.companyNameWidth;
    },
    'opportunityNameWidth': (o) {
      return o.opportunityNameWidth;
    },
    'offeringNameWidth': (o) {
      return o.offeringNameWidth;
    },
    'accountCellWidth': (o) {
      return o.accountCellWidth;
    },
    'basePointsWidth': (o) {
      return o.basePointsWidth;
    },
    'scrollDivStyle': (o) {
      return o.scrollDivStyle;
    },
    'paddingStyle': (o) {
      return o.paddingStyle;
    },
    'innerStyle': (o) {
      return o.innerStyle;
    },
    'opportunity': (o) {
      return o.opportunity;
    },
    'itemStyle': (o) {
      return o.itemStyle;
    },
    'dueDateWidth': (o) {
      return o.dueDateWidth;
    },
    'basePoints': (o) {
      return o.basePoints;
    },
    'kickerPoints': (o) {
      return o.kickerPoints;
    },
    'kickerPointsWidth': (o) {
      return o.kickerPointsWidth;
    },
    'bundles': (o) {
      return o.bundles;
    },
    'stageButtonsWidth': (o) {
      return o.stageButtonsWidth;
    },
    'bundlesWidth': (o) {
      return o.bundlesWidth;
    },
    'disabled': (o) {
      return o.disabled;
    },
    'isDisabled': (o) {
      return o.isDisabled;
    },
    'dueDate': (o) {
      return o.dueDate;
    },
    'endDate': (o) {
      return o.endDate;
    },
    'aatStatus': (o) {
      return o.aatStatus;
    },
    'stage': (o) {
      return o.stage;
    },
    'stages': (o) {
      return o.stages;
    },
    'aatStatusWidth': (o) {
      return o.aatStatusWidth;
    },
    'endDateWidth': (o) {
      return o.endDateWidth;
    },
    evt: (o) {
      return null;
    }
  });
  reflector.registerSetters({
    'scrollAreas': (o, v) {
      return o.scrollAreas = v;
    },
    'length': (o, v) {
      return o.length = v;
    },
    'condition': (o, v) {
      return o.condition = v;
    },
    'scrollArea': (o, v) {
      return o.scrollArea = v;
    },
    'item': (o, v) {
      return o.item = v;
    },
    'visibleItems': (o, v) {
      return o.visibleItems = v;
    },
    'iterableChanges': (o, v) {
      return o.iterableChanges = v;
    },
    'width': (o, v) {
      return o.width = v;
    },
    'value': (o, v) {
      return o.value = v;
    },
    'company': (o, v) {
      return o.company = v;
    },
    'name': (o, v) {
      return o.name = v;
    },
    'offering': (o, v) {
      return o.offering = v;
    },
    'account': (o, v) {
      return o.account = v;
    },
    'accountId': (o, v) {
      return o.accountId = v;
    },
    'formattedValue': (o, v) {
      return o.formattedValue = v;
    },
    'stage': (o, v) {
      return o.stage = v;
    },
    'stages': (o, v) {
      return o.stages = v;
    },
    'disabled': (o, v) {
      return o.disabled = v;
    },
    'isDisabled': (o, v) {
      return o.isDisabled = v;
    },
    'href': (o, v) {
      return o.href = v;
    },
    'companyNameWidth': (o, v) {
      return o.companyNameWidth = v;
    },
    'opportunityNameWidth': (o, v) {
      return o.opportunityNameWidth = v;
    },
    'offeringNameWidth': (o, v) {
      return o.offeringNameWidth = v;
    },
    'accountCellWidth': (o, v) {
      return o.accountCellWidth = v;
    },
    'basePointsWidth': (o, v) {
      return o.basePointsWidth = v;
    },
    'scrollDivStyle': (o, v) {
      return o.scrollDivStyle = v;
    },
    'paddingStyle': (o, v) {
      return o.paddingStyle = v;
    },
    'innerStyle': (o, v) {
      return o.innerStyle = v;
    },
    'opportunity': (o, v) {
      return o.opportunity = v;
    },
    'itemStyle': (o, v) {
      return o.itemStyle = v;
    },
    'basePoints': (o, v) {
      return o.basePoints = v;
    },
    'kickerPoints': (o, v) {
      return o.kickerPoints = v;
    },
    'kickerPointsWidth': (o, v) {
      return o.kickerPointsWidth = v;
    },
    'stageButtonsWidth': (o, v) {
      return o.stageButtonsWidth = v;
    },
    'dueDate': (o, v) {
      return o.dueDate = v;
    },
    'dueDateWidth': (o, v) {
      return o.dueDateWidth = v;
    },
    'endDate': (o, v) {
      return o.endDate = v;
    },
    'endDateWidth': (o, v) {
      return o.endDate = v;
    },
    'aatStatus': (o, v) {
      return o.aatStatus = v;
    },
    'aatStatusWidth': (o, v) {
      return o.aatStatusWidth = v;
    },
    'bundles': (o, v) {
      return o.bundles = v;
    },
    'bundlesWidth': (o, v) {
      return o.bundlesWidth = v;
    },
    'if': (o, v) {},
    'of': (o, v) {},
    'cellWidth': (o, v) {
      return o.cellWidth = v;
    },
    evt: (o, v) {
      return null;
    },
    'style': (o, m) {
      MapWrapper.forEach(m, (v, k) {
        o.style.setProperty(k, v);
      });
    }
  });
  reflector.registerMethods({
    'onScroll': (o, args) {
      o.onScroll(args[0]);
    },
    'setStage': (o, args) {
      return o.setStage(args[0]);
    }
  });
}
setupReflectorForAngular() {
  reflector.registerType(If, {
    'factory': (vp) {
      return new If(vp);
    },
    'parameters': [[ViewContainer]],
    'annotations': [new Viewport(selector: '[if]', bind: {'condition': 'if'})]
  });
  reflector.registerType(For, {
    'factory': (vp) {
      return new For(vp);
    },
    'parameters': [[ViewContainer]],
    'annotations': [
      new Viewport(
          selector: '[for]', bind: {'iterableChanges': 'of | iterableDiff'})
    ]
  });
  reflector.registerType(Compiler, {
    "factory": (changeDetection, templateLoader, reader, parser, compilerCache,
        shadowDomStrategy, tplResolver, cmpUrlMapper, urlResolver,
        cssProcessor) {
      return new Compiler(changeDetection, templateLoader, reader, parser,
          compilerCache, shadowDomStrategy, tplResolver, cmpUrlMapper,
          urlResolver, cssProcessor);
    },
    "parameters": [
      [ChangeDetection],
      [TemplateLoader],
      [DirectiveMetadataReader],
      [Parser],
      [CompilerCache],
      [ShadowDomStrategy],
      [TemplateResolver],
      [ComponentUrlMapper],
      [UrlResolver],
      [CssProcessor]
    ],
    "annotations": []
  });
  reflector.registerType(CompilerCache, {
    'factory': () {
      return new CompilerCache();
    },
    'parameters': [],
    'annotations': []
  });
  reflector.registerType(Parser, {
    'factory': (lexer) {
      return new Parser(lexer);
    },
    'parameters': [[Lexer]],
    'annotations': []
  });
  reflector.registerType(TemplateLoader, {
    "factory": (xhr, urlResolver) {
      return new TemplateLoader(xhr, urlResolver);
    },
    "parameters": [[XHR], [UrlResolver]],
    "annotations": []
  });
  reflector.registerType(TemplateResolver, {
    "factory": () {
      return new TemplateResolver();
    },
    "parameters": [],
    "annotations": []
  });
  reflector.registerType(XHR, {
    "factory": () {
      return new XHRImpl();
    },
    "parameters": [],
    "annotations": []
  });
  reflector.registerType(DirectiveMetadataReader, {
    'factory': () {
      return new DirectiveMetadataReader();
    },
    'parameters': [],
    'annotations': []
  });
  reflector.registerType(Lexer, {
    'factory': () {
      return new Lexer();
    },
    'parameters': [],
    'annotations': []
  });
  reflector.registerType(ExceptionHandler, {
    "factory": () {
      return new ExceptionHandler();
    },
    "parameters": [],
    "annotations": []
  });
  reflector.registerType(LifeCycle, {
    "factory": (exHandler, cd) {
      return new LifeCycle(exHandler, cd);
    },
    "parameters": [[ExceptionHandler], [ChangeDetector]],
    "annotations": []
  });
  reflector.registerType(ShadowDomStrategy, {
    "factory": (strategy) {
      return strategy;
    },
    "parameters": [[NativeShadowDomStrategy]],
    "annotations": []
  });
  reflector.registerType(NativeShadowDomStrategy, {
    "factory": (styleUrlResolver) {
      return new NativeShadowDomStrategy(styleUrlResolver);
    },
    "parameters": [[StyleUrlResolver]],
    "annotations": []
  });
  reflector.registerType(EmulatedUnscopedShadowDomStrategy, {
    "factory": (styleUrlResolver) {
      return new EmulatedUnscopedShadowDomStrategy(styleUrlResolver, null);
    },
    "parameters": [[StyleUrlResolver]],
    "annotations": []
  });
  reflector.registerType(StyleUrlResolver, {
    "factory": (urlResolver) {
      return new StyleUrlResolver(urlResolver);
    },
    "parameters": [[UrlResolver]],
    "annotations": []
  });
  reflector.registerType(UrlResolver, {
    "factory": () {
      return new UrlResolver();
    },
    "parameters": [],
    "annotations": []
  });
  reflector.registerType(ComponentUrlMapper, {
    "factory": () {
      return new ComponentUrlMapper();
    },
    "parameters": [],
    "annotations": []
  });
  reflector.registerType(Content, {
    "factory": (lightDom, el) {
      return new Content(lightDom, el);
    },
    "parameters": [[DestinationLightDom], [NgElement]],
    "annotations": [new Decorator(selector: '[content]')]
  });
  reflector.registerType(StyleInliner, {
    "factory": (xhr, styleUrlResolver, urlResolver) {
      return new StyleInliner(xhr, styleUrlResolver, urlResolver);
    },
    "parameters": [[XHR], [StyleUrlResolver], [UrlResolver]],
    "annotations": []
  });
  reflector.registerType(CssProcessor, {
    "factory": () {
      return new CssProcessor(null);
    },
    "parameters": [],
    "annotations": []
  });
  reflector.registerType(EventManager, {
    "factory": () {
      return new EventManager([], null);
    },
    "parameters": [],
    "annotations": []
  });
  reflector.registerType(PrivateComponentLoader, {
    "factory": (compiler, strategy, eventMgr, reader) {
      return new PrivateComponentLoader(compiler, strategy, eventMgr, reader);
    },
    "parameters": [
      [Compiler],
      [ShadowDomStrategy],
      [EventManager],
      [DirectiveMetadataReader]
    ],
    "annotations": []
  });
}
